#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Sep 22 11:40:42 2020

@author: zachariah_liu
This code is the test purpose for practicing coding about hosptal regitered


"""
from urllib.request import urlretrieve
from selenium import webdriver
from time import sleep
from selenium.webdriver.support.ui import Select
import datetime
import pytesseract
from PIL import Image
import re

## Varibales Definition
DoctorName = input('請輸入醫生姓名:')
patientID = input('請輸入身分證字號(字母大寫):')
BrowserVer = 'Version 85.0.4183.121'
Birthday = input('生日(民國38年5月6日則輸入38,05,06): ')
## -------------------------

birth = Birthday.split(',') #Split the YEAR/MONTH/DATE
url = 'https://reg.ntuh.gov.tw/webadministration/DoctorServiceQueryByDrName.aspx?HospCode=T0' # NTU Registerd Homepage
rootHome = 'https://reg.ntuh.gov.tw/webadministration/'

"""Chrome Hide the windows, webdriver have to add chrome_options=options
options = webdriver.ChromeOptions()
options.add_argument('--headless') # 啟動無頭模式
# chrome_options.add_argument('--disable-gpu') # windowsd必須加入此行 原文網址：https://itw01.com/FYB2UED.html
"""

driver = webdriver.Chrome(executable_path='./chromedriver')
driver.set_page_load_timeout(60)
driver.get(url)



def InputDoctorName(driver,DoctorName): # Find your requirement doctor
    element_docNameField = driver.find_element_by_id('DoctorNameInputTextBox')
    element_docNameField.send_keys(DoctorName)
    element_submitBTN = driver.find_element_by_id('SubmitQueryButton')
    element_submitBTN.click()

InputDoctorName(driver,DoctorName)

def InputPersonalDate(driver, patientID,birth): #Input your personal data or info
    links = driver.find_elements_by_link_text('掛號')
    links[0].click()

    element_radioID = driver.find_element_by_id('radInputNum_1')
    element_radioID.click()
    sleep(1)
    element_fieldID = driver.find_element_by_id('txtIdno')
    element_fieldID.send_keys(patientID)
   
    yearSelect = Select(driver.find_element_by_name('ddlBirthYear'))
    yearSelect.select_by_visible_text(birth[0])
    monthSelect= Select(driver.find_element_by_name('ddlBirthMonth'))
    monthSelect.select_by_visible_text(birth[1])
    dateSelect= Select(driver.find_element_by_name('ddlBirthDay'))
    dateSelect.select_by_visible_text(birth[2])

InputPersonalDate(driver, patientID, birth)
sleep(2)

def verifyStr(driver): # Verify the picture to string
    ISOTIMEFORMAT = '%Y%m%d%H%M%S'
   
    picSrc = driver.find_element_by_id('imgVlid').get_attribute('src')
    picName = 'veriStr'+ datetime.datetime.now().strftime(ISOTIMEFORMAT)+'.gif'
    urlretrieve(picSrc, picName) # download the link file
    image = Image.open('./'+picName)
    texttemp = pytesseract.image_to_string(image, lang='eng').strip()
    text = texttemp[0:6]
    """    
    text=''
    """
    while not re.fullmatch('^[0-9a-zA-Z]{6}$', text):
        veriBTNreload = driver.find_element_by_id('btnReNewNum')
        veriBTNreload.click()
        sleep(1)
        picSrc = driver.find_element_by_id('imgVlid').get_attribute('src')
        picName = 'veriStr'+ datetime.datetime.now().strftime(ISOTIMEFORMAT)+'.gif'
        urlretrieve(picSrc, picName) # download the link file
        image = Image.open('./'+picName)
        texttemp = pytesseract.image_to_string(image, lang='eng').strip()
        text = texttemp[0:6]    
   
    return text


tempstr=verifyStr(driver)
txtVeriForm = driver.find_element_by_id('txtVerifyCode')
txtVeriForm.send_keys(tempstr)
"""
driver.find_element_by_id('btnOK').click()
txtVeriFail = driver.find_element_by_id('ErrorMessageText').text.strip()

if txtVeriFail == '驗證碼輸入錯誤，請重新輸入':
    verifyStr(driver)
else:
        driver.find_element_by_id('btnOK').click()
"""
